'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Data {

  constructor(value, source, options) {
    this.value = value;
    this.orig = value;
    this.source = source || '/';
    this.options = options || {};
    this.temp = {};
    this.root = this;
    this.status = new Promise(resolve => {
      this.done = resolve;
    });
  }

  inspect(depth, options) {
    const newOptions = Object.assign({}, options, {
      depth: options.depth === null ? null : options.depth - 1
    });
    const inner = _util2.default.inspect(this.value, newOptions);
    return `${options.stylize(this.constructor.name, 'class')} at ${this.source} ${inner} `;
  }

  sub(key) {
    const sub = new Data(this.value[key], `${this.source.replace(/\/$/, '')}/${key}`, this.options);
    sub.parent = this;
    sub.root = this.root;
    return sub;
  }

  get clone() {
    return Object.assign(Object.create(this), this);
  }
}

exports.default = Data;