'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

var _Schema = require('./type/Schema');

var _Schema2 = _interopRequireDefault(_Schema);

var _Data = require('./Data');

var _Data2 = _interopRequireDefault(_Data);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class SchemaError extends Error {

  constructor(schema, data, msg) {
    super(msg);
    this.schema = schema;
    if (data) this.data = data;
  }

  inspect() {
    return `Error at ${this.data.source}: ${this.message} `;
  }

  get text() {
    return `__${this.message}__

> Given value was: \`${_util2.default.inspect(this.data.value)}\`
> At path: \`${this.data.source}\`

But __${this.schema._title}__ ${this.schema._detail}:
${this.schema.description}`;
  }
}

exports.default = SchemaError;