'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _builder = require('./builder');

var val = _interopRequireWildcard(_builder);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

const presets = {
  word: () => new val.String().notMatch(/\s/).min(1),
  character: () => new val.String().length(1),
  md5: () => new val.String().lowerCase().match(/^[a-f0-9]{32}$/),
  sha1: () => new val.String().lowerCase().match(/^[a-f0-9]{40}$/),
  sha256: () => new val.String().lowerCase().match(/^[a-f0-9]{64}$/),

  hostOrIP: () => new val.Logic().allow(new val.Domain()).or(new val.IP()),

  plz: () => new val.Number().positive().max(99999).format('00000')
};

exports.default = presets;